## Client Prototype

## Description

[Nest](https://github.com/nestjs/nest) framework TypeScript starter repository.

Client Prototype is just sending the query request command to microservices and microservice return the response.


### REQUEST URL

#### REQUEST - Plantation site
```bash
POST http://localhost:3003/request
```
```bash
{
	"type": "site",
	"databaseName": "fisJRSB",
}
```

### REQUEST - FisApp DATASERVICE
### Method 1 - Data Request
```bash
 POST   http://localhost:3003/request 
```
```bash
 {
    	"className":"APAccountProfileDataService",
        "type": "dataservice",
        "returnFormatType": "byBatchOf10",
        "filter": "a",
        "requestID": "BBB"
 }
```

### Method 2 - fisApp
```bash
 POST   http://localhost:3003/default
```

```bash
{
  "header": {
    "messageType": "Query",
    "messageID": "942ecfe2-8734-4cff-998e-6a2a5a39c464",
    "messageName": "Query",
    "dateCreated": "2022-03-11T02:19:50.923Z",
    "isAggregate": false,
    "messageProducerInformation": {
      "origin": {
        "userApplication": {
          "userAppId": "getQueryMessage",
          "userAppName": "Client"
        }
      },
      "components": "Presentation"
    },
    "security": {
      "ucpId": "ABC"
    },
    "messageDataLocation": {
      "isEmbaded": true
    },
    "messageDataFormat": {
      "dataFormat": "Json"
    },
    "requestExecutionMode": 0,
    "resquestTimeOut": 0,
    "query": "General"
  },
  "data": {
    "className": "APAccountProfileDataService",
    "type": "dataservice",
    "returnFormatType": "byBatchOf10",
    "filter": "a",
    "requestID": "BBB"
  }
}

```

### Method 3 - Microservice command 

#### Observable
```bash
this.client.send<string, FisQueryMessage>('QUERY',<FisQueryMessage>)
```




## Installation

```bash
$ npm install
```

## Running the app

```bash
# development
$ npm run start

# watch mode
$ npm run start:dev

# production mode
$ npm run start:prod
```

## Test

```bash
# unit tests
$ npm run test

# e2e tests
$ npm run test:e2e

# test coverage
$ npm run test:cov
```

## Support

Nest is an MIT-licensed open source project. It can grow thanks to the sponsors and support by the amazing backers. If you'd like to join them, please [read more here](https://docs.nestjs.com/support).

## Stay in touch

- Author - [Kamil Myśliwiec](https://kamilmysliwiec.com)
- Website - [https://nestjs.com](https://nestjs.com/)
- Twitter - [@nestframework](https://twitter.com/nestframework)

## License

Nest is [MIT licensed](LICENSE).
